# -*- encoding: utf-8 -*-
##############################################################################
#
#    Author: Frank Carvajal. Copyright ClearCorp SA
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
#from tools import debug

class account_journal(osv.osv):
	_name = "account.journal"
	_inherit = "account.journal"
	_columns = {
		#'type': fields.selection([('sale', 'Sale'),
		#						('sale_refund','Sale Refund'),
		#						('purchase', 'Purchase'),
		#						('purchase_refund','Purchase Refund'),
		#						('cash', 'Cash'),
		#						('bank', 'Bank and Cheques'),
		#						('general', 'General'),
		#						('situation', 'Opening/Closing Situation'),
		#						('payment','Payment method')], 'Type', size=32, required=True,
		#						help="Select 'Sale' for Sale journal to be used at the time of making invoice."\
		#						" Select 'Purchase' for Purchase Journal to be used at the time of approving purchase order."\
		#						" Select 'Cash' to be used at the time of making payment."\
		#						" Select 'General' for miscellaneous operations."\
		#						" Select 'Opening/Closing Situation' to be used at the time of new fiscal year creation or end of year entries generation."),
		'payment_method_customer'   : fields.boolean('Payment Method Customer'),
		'payment_method_supplier'   : fields.boolean('Payment Method Supplier'),
		'payment_verification'      : fields.boolean('Payment Verification'),
		'transfers'      : fields.boolean('Transfers'),
		'check'      : fields.boolean('Check'),
		
	}
account_journal()

class account_voucher_journal_payment(osv.osv):
	_name = 'account.voucher'
	_inherit = 'account.voucher'
	_description = 'Accounting Voucher'

	def _compute_writeoff_amount(self, cr, uid, line_dr_ids, line_cr_ids, amount):
		debit = credit = 0.0
		for l in line_dr_ids:
			debit += l['amount']
		for l in line_cr_ids:
			credit += l['amount']
		return abs(amount - abs(credit - debit))

	#def onchange_partner_id(self, cr, uid, ids, partner_id, journal_id, price, currency_id, ttype, date, context=None):
		#"""price
		#Returns a dict that contains new values and context

		#@param partner_id: latest value from user input for field partner_id
		#@param args: other arguments
		#@param context: context arguments, like lang, time zone

		#@return: Returns a dict which contains new values, and context
		#"""
		#if context is None:
			#context = {}
		#if not journal_id:
			#return {}
		#context_multi_currency = context.copy()
		#if date:
			#context_multi_currency.update({'date': date})

		#line_pool = self.pool.get('account.voucher.line')
		#line_ids = ids and line_pool.search(cr, uid, [('voucher_id', '=', ids[0])]) or False
		#if line_ids:
			#line_pool.unlink(cr, uid, line_ids)

		#currency_pool = self.pool.get('res.currency')
		#move_line_pool = self.pool.get('account.move.line')
		#partner_pool = self.pool.get('res.partner')
		#journal_pool = self.pool.get('account.journal')

		#vals = self.onchange_journal(cr, uid, ids, journal_id, [], False, partner_id, False, False, False, False, context)
		#vals = vals.get('value')
		#currency_id = vals.get('currency_id', currency_id)
		#default = {
			#'value':{'line_ids':[], 'line_dr_ids':[], 'line_cr_ids':[], 'pre_line': False, 'currency_id':currency_id},
		#}

		#if not partner_id:
			##debug("DEFAULT EN EL IF SIN PARTNER")
			##debug(default)
			#return default

		#if not partner_id and ids:
			#line_ids = line_pool.search(cr, uid, [('voucher_id', '=', ids[0])])
			#if line_ids:
				#line_pool.unlink(cr, uid, line_ids)
			#return default

		#journal = journal_pool.browse(cr, uid, journal_id, context=context)
		#partner = partner_pool.browse(cr, uid, partner_id, context=context)
		#account_id = False
		#if journal.type in ('sale','sale_refund'):
			#account_id = partner.property_account_receivable.id
		#elif journal.type in ('purchase', 'purchase_refund','expense'):
			#account_id = partner.property_account_payable.id
		#else:
			#account_id = journal.default_credit_account_id.id or journal.default_debit_account_id.id

		#default['value']['account_id'] = account_id

		#if journal.type not in ('cash', 'bank','payment'):
			##debug("DEFAULT EN EL IF journal no de dinero banco o pagos")
			##debug(default)
			#return default

		#total_credit = 0.0
		#total_debit = 0.0
		#account_type = 'receivable'
		#if ttype == 'payment':
			#account_type = 'payable'
			#total_debit = price or 0.0
		#else:
			#total_credit = price or 0.0
			#account_type = 'receivable'

		#if not context.get('move_line_ids', False):
			#domain = [('state','=','valid'), ('account_id.type', '=', account_type), ('reconcile_id', '=', False), ('partner_id', '=', partner_id), ('journal_id.payment_method','=',False)]
			#if context.get('invoice_id', False):
				#domain.append(('invoice', '=', context['invoice_id']))
			#ids = move_line_pool.search(cr, uid, domain, context=context)
			##debug("no encuentra movelines en el contexto")
			##debug(ids)
		#else:
			#ids = context['move_line_ids']
			##debug("SI encuentra movelines en el contexto")
			##debug(ids)
		#ids.reverse()
		#moves = move_line_pool.browse(cr, uid, ids, context=context)

		#company_currency = journal.company_id.currency_id.id
		#if company_currency != currency_id and ttype == 'payment':
			#total_debit = currency_pool.compute(cr, uid, currency_id, company_currency, total_debit, context=context_multi_currency)
		#elif company_currency != currency_id and ttype == 'receipt':
			#total_credit = currency_pool.compute(cr, uid, currency_id, company_currency, total_credit, context=context_multi_currency)

		#for line in moves:
			#if line.credit and line.reconcile_partial_id and ttype == 'receipt':
				#continue
			#if line.debit and line.reconcile_partial_id and ttype == 'payment':
				#continue
			#total_credit += line.credit or 0.0
			#total_debit += line.debit or 0.0
		#for line in moves:
			#if line.credit and line.reconcile_partial_id and ttype == 'receipt':
				#continue
			#if line.debit and line.reconcile_partial_id and ttype == 'payment':
				#continue
			#original_amount = line.credit or line.debit or 0.0
			#amount_unreconciled = currency_pool.compute(cr, uid, line.currency_id and line.currency_id.id or company_currency, currency_id, abs(line.amount_residual_currency), context=context_multi_currency)
			#rs = {
				#'name':line.move_id.name,
				#'type': line.credit and 'dr' or 'cr',
				#'move_line_id':line.id,
				#'account_id':line.account_id.id,
				#'amount_original': currency_pool.compute(cr, uid, line.currency_id and line.currency_id.id or company_currency, currency_id, line.currency_id and abs(line.amount_currency) or original_amount, context=context_multi_currency),
				#'date_original':line.date,
				#'date_due':line.date_maturity,
				#'amount_unreconciled': amount_unreconciled,
			#}

			#if line.credit:
				#amount = min(amount_unreconciled, currency_pool.compute(cr, uid, company_currency, currency_id, abs(total_debit), context=context_multi_currency))
				#rs['amount'] = amount
				#total_debit -= amount
			#else:
				#amount = min(amount_unreconciled, currency_pool.compute(cr, uid, company_currency, currency_id, abs(total_credit), context=context_multi_currency))
				#rs['amount'] = amount
				#total_credit -= amount

			#default['value']['line_ids'].append(rs)
			#if rs['type'] == 'cr':
				#default['value']['line_cr_ids'].append(rs)
			#else:
				#default['value']['line_dr_ids'].append(rs)

			#if ttype == 'payment' and len(default['value']['line_cr_ids']) > 0:
				#default['value']['pre_line'] = 1
			#elif ttype == 'receipt' and len(default['value']['line_dr_ids']) > 0:
				#default['value']['pre_line'] = 1
			#default['value']['writeoff_amount'] = self._compute_writeoff_amount(cr, uid, default['value']['line_dr_ids'], default['value']['line_cr_ids'], price)
		##debug(price)
		##debug(default)
		#return default

account_voucher_journal_payment()
